## Blundell Powell Estimator

library(np)

bpe <- function(y, x, v.hat, h= 1) {

kernfun <- function(x,order=2){
   # second order kernels
   if (order==2) {dnorm(x)} else {

   #fourth order kernel
   if (order==4) {0.5*(3-x^2)*dnorm(x)} else {

   #sixth order kernel
   if (order==6) {1/8 *(15 - 10*x^2 + x^4)*dnorm(x)  } }}
}


reg <- cbind(x,v.hat)

bw <- npregbw(ydat=y, xdat= reg, bws = h*sd(reg), bandwidth.compute = FALSE)#,itmax = 3, nmulti=1)
model <- npreg(bws = bw)
g.hat <- model$mean


Sw <- 0
hh1 <- h * sd(g.hat) 
hh2 <- h * sd(v.hat) 


for (i in 1:(length(y)-1)) {
 for (j in (i+1):length(y)) {
 
 omega.ij <- kernfun((g.hat[i]-g.hat[j])/hh1)*kernfun((v.hat[i]-v.hat[j])/hh2)
 Sw <- Sw +  omega.ij * (x[i,]-x[j,])%*%t(x[i,]-x[j,])
 
 }
}

beta.hat <- eigen(Sw)$vectors[,dim(x)[2]]

#list(eigen(Sw),beta.hat[-1]/beta.hat[1])
beta.hat[-1]/beta.hat[1]
}


#bpe(y,x,v.hat,h1=0.25,h2=0.3)
