library(np)

ksendo <-   function(y, x, v.hat, init.beta=0, init.h=c(.2,.2), optim.bw=TRUE) {

loclink <- function(para, y, x, v.hat, h) {

reg <- cbind(x%*%c(1,para) ,v.hat)

D.inv <- solve(cov(reg))
e <- eigen(D.inv)
B <- e$vectors  %*% diag(sqrt(e$values)) %*% t(e$vectors ) 
reg <- reg%*%B

r <- npksum(reg, y, leave.one.out=TRUE, bandwidth.divide=TRUE, bws=h)$ksum  /
      npksum(reg, leave.one.out=TRUE, bandwidth.divide=TRUE, bws=h)$ksum

return(r)
}

loglike <- function(para, y, x, v.hat) {

 gi <- loclink(para[-((length(para)-1):length(para))], y=y, x=x, v.hat=v.hat,h=para[(length(para)-1):length(para)])
 null <- y==0

 t1 <- sum(log(gi[!null ]))
 t2 <- sum(log((1-gi)[null]))
 (t1 + t2)*(-1)

}

loglike2 <- function(para, bw, y, x, v.hat) {
   loglike(c(para,bw),y,x,v.hat)
  }
  

if (optim.bw == FALSE) {
 
  result <- optim(init.beta,loglike2, bw=init.h,y=y,x=x,v.hat=v.hat, 
               control=list(fnscale=1, reltol=0.0001,maxit=10),method="BFGS")
output <- c(result$par,result$value)

} else {

init <- c(init.beta, init.h)

result <- optim(init,loglike, y=y,x=x,v.hat=v.hat,
               control=list(fnscale=1, reltol=0.0001,maxit=10),method="BFGS")   

output <- c(result$par,result$value)   }

output

}

